unit uflu41;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, LvlGraphCtrl,
  ComCtrls, urawdata, FPimage,
{$IFDEF OLD_FLUCAR}
  uprincipal,
{$ENDIF}
  uprincipal_raw, uactoresflucar;

type

  { TForm1 }

  TForm1 = class(TForm)
    btOldFlucar: TButton;
    btPrincipal_raw: TButton;
    Lienzo: TLvlGraphControl;
    TV_Flujo: TTreeView;
    Taps: TCheckBox;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Timer1: TTimer;
    procedure btOldFlucarClick(Sender: TObject);
    procedure btPrincipal_rawClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{ TForm1 }

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  timer1.Enabled := False;
  if paramcount = 2 then
    correr_raw_con_modificaciones(ParamStr(1), ParamStr(2));
end;

procedure TForm1.btOldFlucarClick(Sender: TObject);
begin
  {$IFDEF OLD_FLUCAR}
  if (OpenDialog1.Execute) then
    Principal(OpenDialog1.FileName);
  {$ELSE}
    btOldFlucar.Enabled:= false;
{$ENDIF}
end;

procedure TForm1.btPrincipal_rawClick(Sender: TObject);
var
  RootNode: TTreeNode;
  sala: TSalaFlucar;
  indice: Integer;
  NodoBarras, NodoTransformer: TLvlGraphNode;
begin
  if (OpenDialog2.Execute) then
    sala:=Principal_Raw(OpenDialog2.FileName,taps.Checked);//    Principal_Raw( OpenDialog2.FileName );
  RootNode := TV_flujo.Items.AddFirst(nil, OpenDialog2.FileName);

  with Lienzo do
  begin
    for indice:=0 to sala.Barras.Count-1 do
      NodoBarras:=Graph.GetNode(IntToStr(TRaw_Bus(sala.Barras[indice]).I),TRUE);

    for indice:=0 to sala.Lineas.Count-1 do
      Graph.GetEdge(IntToStr(TRaw_Branch(sala.Lineas[indice]).I), IntToStr(TRaw_Branch(sala.Lineas[indice]).J), true);

    for indice:=0 to sala.TrafosAdjust.Count-1 do
    begin
      NodoTransformer:=Graph.GetNode('T'+IntToStr(indice)+(TRaw_TransformerAdjust(sala.TrafosAdjust[indice]).Name), TRUE);
      Graph.GetEdge(IntToStr(TRaw_TransformerAdjust(sala.TrafosAdjust[indice]).I), NodoTransformer.Caption, true);
      Graph.GetEdge(NodoTransformer.Caption, IntToStr(TRaw_TransformerAdjust(sala.TrafosAdjust[indice]).J), true);
      if TRaw_TransformerAdjust(sala.TrafosAdjust[indice]).K<>0 then
         Graph.GetEdge(NodoTransformer.Caption, IntToStr(TRaw_TransformerAdjust(sala.TrafosAdjust[indice]).K), true);
    end;

    NodeStyle.Shape := lgnsEllipse;
    NodeStyle.Width := 15;
    NodeStyle.GapTop := 8;
    NodeStyle.CaptionPosition := lgncBottom;
    Font.Size:= 11;

  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  RootNode: TTreeNode;
begin
  RootNode := TV_flujo.Items.AddFirst(nil, OpenDialog2.FileName);
  TV_flujo.Items.AddChild(RootNode, 'DESCRIPCION');
  TV_flujo.Items.AddChild(RootNode, 'BARRAS');
  TV_flujo.Items.AddChild(RootNode, 'CARGAS');
  TV_flujo.Items.AddChild(RootNode, 'LINEAS');
  TV_flujo.Items.AddChild(RootNode, 'TRAFOS');
  TV_flujo.Items.AddChild(RootNode, 'SHUNTS');
  RootNode.Expanded := True;
end;


initialization
  {$I uflu41.lrs}

end.

